<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */

/**
 * Définition d’une classe qui stocke des informations sur une personne.
 * 
 */
class Personne
{ 
	// Définition des attributs.
	//  
	public  $nom; // nom de la personne
	public  $prenom; // prenom de la personne
	public  $langue = "fr_FR"; // langue de la personne
	                         // français par défaut 
	                         
	private $timestamp; // date/heure de création (privé)

	// Définition des méthodes : 

	/**
	* le constructeur
	* @param [type] $prenom [description]
	* @param [type] $nom    [description]
	*/
	public function __construct($sPrenom,$sNom)
	{ 
		// Init le nom et le prenom 
		// avec les valeurs passées en paramètre. 
		$this->prenom = $sPrenom; 
		$this->nom = $sNom; 

		// Init timestamp avec la fonction time(). 
		$this->timestamp = time(); 
	} 


	/**
	* Le destructeur
	* Pour supprimer des ressources...
	*/
	public function __destruct()
	{ 
		// afficher un message. 
		echo "<p><b>Suppression de ".$this->nom." ".$this->prenom."</b></p>"; 
	} 



	/**
	* Conversion de l’objet en chaîne
	* @return string [description]
	*/
	public function __toString()
	{ 
		// Retourne juste le nom et le prenom. 
		return "__toString = ".$this->nom." - ".$this->prenom; 
	} 



	/**
	* Met à jour la langue de l’utilisateur.
	* @param  [type] $sLangue [description]
	* @return [type]         [description]
	*/
	public function langue($sLangue)
	{ 
		$this->langue = $sLangue; 
	} 


	/**
	* met en forme la date/heure de création de la personne.
	*  
	*/
	private function setTimestamp()
	{ 
		setlocale(LC_TIME,$this->langue); 
		return strftime('%c', $this->timestamp); 
	}

	/**
	* Renvoie les informations de la personne
	* @return [type] [description]
	*/
	public function getInfos()
	{ 
		$sDateCreate = $this->setTimestamp(); 
		return $this->prenom." ".$this->nom." - ".$sDateCreate; 
	} 

} 



/**
 * Définition d’une classe qui hérite de la première.
 */
class PersonneHum extends Personne
{ 
	// Définition des attributs complémentaires. 
	public $sexe; // sexe de la personne (homme ou femme) 

	// Définition des méthodes complémentaires. 
	
	/**
	 * Le constructeur
	 * @param [type] $prenom   [description]
	 * @param [type] $sexe [description]
	 */
	public function __construct($sPrenom, $sName, $sSexe)
	{ 
		// Appel au constructeur de la classe mère 
		parent::__construct ($sPrenom, $sName); 

		$this->sexe = $sSexe; 
	} 

	/**
	 * Renvoie le sexe de la personne
	 * @return [type] [description]
	 */
	public function getSexe()
	{ 
		return $this->sexe; 
	} 
} 

// instanciation de la classe

// Instanciation d’un objet. 
$oProgrammeur = new PersonneHum("Matthieu", "Developpement", "Homme"); 


echo $oProgrammeur->getInfos()."<br/>";// existe par héritage 
echo $oProgrammeur->prenom."<br/>";// existe par héritage

echo $oProgrammeur->getSexe()."<br/>";// existe dans la classe fille


?>
